<?
/**
 * Samurai_Iterator
 * 
 * Samurai用走査クラスの実装。
 * 
 * @package    Samurai
 * @subpackage Samurai
 * @copyright  Befool,Inc.
 * @author     Satoshi Kiuchi <satoshi.kiuchi@befool.co.jp>
 * @license    http://opensource.org/licenses/bsd-license.php  The modified BSD License
 */
class Samurai_Iterator implements Iterator
{
    protected
        $_elements = array();
    
    
    /**
     * コンストラクタ。
     * @access     public
     */
    public function __construct()
    {
        
    }
    
    
    /**
     * 要素の追加。
     * @access     public
     * @param      mixed   $element   要素
     * @param      mixed   $key       キー
     */
    public function addElement($element, $key=NULL)
    {
        if($key === NULL){
            $this->_elements[] = $element;
        } else {
            $this->_elements[$key] = $element;
        }
    }
    
    
    /**
     * 空にする。
     * @access     public
     */
    public function clear()
    {
        $this->_elements = array();
    }
    
    
    
    
    
    /**
     * implements.
     */
    public function rewind()
    {
        reset($this->_elements);
    }
    public function key()
    {
        return key($this->_elements);
    }
    public function current()
    {
        return current($this->_elements);
    }
    public function next()
    {
        next($this->_elements);
    }
    public function valid()
    {
        $current = current($this->_elements);
        if($current === false) $this->rewind();
        return $current !== false;
    }
}
